"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _objects = _interopRequireDefault(require("shallow-equal/objects"));

var _dateUtils = require("./dateUtils");

var _jalaaliJs = _interopRequireDefault(require("jalaali-js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DATE_SEPERATOR = '/'; // this is arabic date seperator ' ؍' but it is right to left glyph and as the numbers are left to right there will be caret position problem

var MIDDLE_SEPERATOR = '\xa0';
var TIME_SEPERATOR = ':';
var EMPTY_VALUE = "    ".concat(DATE_SEPERATOR, "  ").concat(DATE_SEPERATOR, "  ").concat(MIDDLE_SEPERATOR, "  ").concat(TIME_SEPERATOR, "  ");

var DateInput = /*#__PURE__*/function (_Component) {
  _inherits(DateInput, _Component);

  var _super = _createSuper(DateInput);

  function DateInput(_props) {
    var _this;

    _classCallCheck(this, DateInput);

    _this = _super.call(this, _props);

    _defineProperty(_assertThisInitialized(_this), "readValuesFromProps", function (props) {
      var j = (0, _dateUtils.readDateFromValue)(props.value);
      var valueIsValid = !!j;
      var value = valueIsValid ? (props.gregorian ? (0, _dateUtils.formatGregorian)(j.value) : (0, _dateUtils.formatJalaali)(j.j)) + MIDDLE_SEPERATOR + (0, _dateUtils.formatTime)(j.value) : '';
      var date = valueIsValid ? j.value : null;
      var iso = valueIsValid ? j.value.toISOString() : '';

      var valueToShow = _this.mapValue(value, props.numberFormat);

      return {
        value: value,
        valueToShow: valueToShow,
        valueIsValid: valueIsValid,
        iso: iso,
        date: date,
        selectionStart: undefined,
        selectionEnd: undefined
      };
    });

    _defineProperty(_assertThisInitialized(_this), "handleFocus", function (event) {
      if ((0, _dateUtils.isValueEmpty)(_this.values.value)) {
        _this.jumpToDay();
      }

      if (_this.props.onFocus) {
        _this.props.onFocus(event);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleBlur", function (event) {
      var splittedValue = (0, _dateUtils.splitDateTimeValue)(_this.values.value);

      _this.updateState(_this.sanitizeValues(splittedValue, _this.values, true, true, true, true, true));

      if (_this.props.onBlur) {
        _this.props.onBlur(event);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "jumpToNext", function () {
      var selectionStart = _this.inputRef.current.selectionStart;
      var splittedValue = (0, _dateUtils.splitDateTimeValue)(_this.values.value);

      if (_this.isCaretAtDay(splittedValue, selectionStart)) {
        _this.updateState(_this.sanitizeValues(splittedValue, _this.values, true, false, false, false, false));

        _this.jumpToMonth();

        return true;
      } else if (_this.isCaretAtMonth(splittedValue, selectionStart)) {
        _this.updateState(_this.sanitizeValues(splittedValue, _this.values, false, true, false, false, false));

        _this.jumpToYear();

        return true;
      } else if (_this.isCaretAtYear(splittedValue, selectionStart)) {
        _this.updateState(_this.sanitizeValues(splittedValue, _this.values, false, false, true, false, false));

        _this.jumpToHour();

        return true;
      } else if (_this.isCaretAtHour(splittedValue, selectionStart)) {
        _this.updateState(_this.sanitizeValues(splittedValue, _this.values, false, false, false, true, false));

        _this.jumpToMinute();

        return true;
      } else if (_this.isCaretAtMinute(splittedValue, selectionStart)) {
        _this.updateState(_this.sanitizeValues(splittedValue, _this.values, false, false, false, false, true));
      }

      return false;
    });

    _defineProperty(_assertThisInitialized(_this), "jumpToPrevious", function () {
      var selectionStart = _this.inputRef.current.selectionStart;
      var splittedValue = (0, _dateUtils.splitDateTimeValue)(_this.values.value);

      if (_this.isCaretAtDay(splittedValue, selectionStart)) {
        _this.updateState(_this.sanitizeValues(splittedValue, _this.values, true, false, false, false, false));
      } else if (_this.isCaretAtMonth(splittedValue, selectionStart)) {
        _this.updateState(_this.sanitizeValues(splittedValue, _this.values, false, true, false, false, false));

        _this.jumpToDay();

        return true;
      } else if (_this.isCaretAtYear(splittedValue, selectionStart)) {
        _this.updateState(_this.sanitizeValues(splittedValue, _this.values, false, false, true, false, false));

        _this.jumpToMonth();

        return true;
      } else if (_this.isCaretAtHour(splittedValue, selectionStart)) {
        _this.updateState(_this.sanitizeValues(splittedValue, _this.values, false, false, false, true, false));

        _this.jumpToYear();

        return true;
      } else if (_this.isCaretAtMinute(splittedValue, selectionStart)) {
        _this.updateState(_this.sanitizeValues(splittedValue, _this.values, false, false, false, false, true));

        _this.jumpToHour();

        return true;
      }

      return false;
    });

    _defineProperty(_assertThisInitialized(_this), "jumpToDay", function () {
      _this.values.selectionStart = 10;
      _this.values.selectionEnd = 10;

      _this.inputRef.current.setSelectionRange(_this.values.selectionStart, _this.values.selectionEnd);
    });

    _defineProperty(_assertThisInitialized(_this), "jumpToMonth", function () {
      _this.values.selectionStart = 7;
      _this.values.selectionEnd = 7;

      _this.inputRef.current.setSelectionRange(_this.values.selectionStart, _this.values.selectionEnd);
    });

    _defineProperty(_assertThisInitialized(_this), "jumpToYear", function () {
      _this.values.selectionStart = 4;
      _this.values.selectionEnd = 4;

      _this.inputRef.current.setSelectionRange(_this.values.selectionStart, _this.values.selectionEnd);
    });

    _defineProperty(_assertThisInitialized(_this), "jumpToHour", function () {
      _this.values.selectionStart = 13;
      _this.values.selectionEnd = 13;

      _this.inputRef.current.setSelectionRange(_this.values.selectionStart, _this.values.selectionEnd);
    });

    _defineProperty(_assertThisInitialized(_this), "jumpToMinute", function () {
      _this.values.selectionStart = 16;
      _this.values.selectionEnd = 16;

      _this.inputRef.current.setSelectionRange(_this.values.selectionStart, _this.values.selectionEnd);
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyDown", function (event) {
      // console.log('keyCode: ', event.keyCode, 'key: ', event.key);
      if (_this.props.disabled || _this.props.readOnly) {
        event.preventDefault();
      } else if (event.keyCode === 8) {
        //backspace
        event.preventDefault();

        _this.updateState(_this.deleteValue(event.target, -1));
      } else if (event.keyCode === 46) {
        //delete
        event.preventDefault();

        _this.updateState(_this.deleteValue(event.target, 1));
      } else if (event.keyCode >= 48 && event.keyCode <= 57) {
        //digits
        event.preventDefault(); // console.log('digit');

        _this.updateState(_this.updateValue(event.target, (event.keyCode - 48).toString(), _this.props.numberFormat));
      } else if (event.keyCode >= 96 && event.keyCode <= 105) {
        //digits
        event.preventDefault(); // console.log('digit');

        _this.updateState(_this.updateValue(event.target, (event.keyCode - 96).toString(), _this.props.numberFormat));
      } else if (event.key >= '۰' && event.key <= '۹' || event.key >= '٠' && event.key <= '٩') {
        //digits
        event.preventDefault(); // console.log('digit');

        _this.updateState(_this.updateValue(event.target, event.key, _this.props.numberFormat));
      } else if (event.key === '.' || event.key === '/' || event.key === '-' || event.key === '*' || event.key === '#' || event.keyCode === 188 || event.keyCode === 189 || event.keyCode === 190 || event.keyCode === 191) {
        event.preventDefault();

        if (event.ctrlKey || event.shiftKey || event.metaKey || event.key === '#') {
          _this.jumpToPrevious();
        } else {
          _this.jumpToNext();
        }
      } else if (event.keyCode >= 35 && event.keyCode <= 40) {//arrows
      } else if (event.keyCode === 9) {
        //tab
        if (Math.abs(_this.inputRef.current.selectionStart - _this.inputRef.current.selectionEnd) === _this.inputRef.current.value.length) {
          return;
        }

        if (event.ctrlKey || event.shiftKey || event.metaKey) {
          if (_this.jumpToPrevious()) event.preventDefault();
        } else {
          if (_this.jumpToNext()) event.preventDefault();
        }
      } else if (event.keyCode === 13) {
        //return
        _this.hideKeyboard();
      } else if ((event.ctrlKey || event.metaKey) && (event.keyCode === 67 || event.keyCode === 86 || event.keyCode === 88)) {//copy/paste/cut
      } else if ((event.ctrlKey || event.metaKey) && event.keyCode === 82) {//refresh key
      } else if ((event.ctrlKey || event.metaKey) && event.keyCode === 73) {//inspector
      } else if ((event.ctrlKey || event.metaKey) && event.keyCode === 65) {//select all
      } else if ((event.ctrlKey || event.metaKey) && event.keyCode === 76) {//location focus
      } else if (event.keyCode === 115) {
        // F4
        if (_this.props.onShowDialog) {
          event.preventDefault();

          _this.props.onShowDialog();
        }
      } else if (event.keyCode >= 112 && event.keyCode <= 123) {// All other F keys
      } else if (event.keyCode === 229) {
        //android bug workaround
        //K1 : I guess that we have to save the caret position as the input will change it, we need it to know where we have to jump to in handleInput function
        _this.values.selectionStart = _this.inputRef.current.selectionStart;
        _this.values.selectionEnd = _this.inputRef.current.selectionEnd;
      } else {
        // console.log('other');
        //console.log('keyCode: ', event.keyCode, 'key: ', event.key, 'ctrlKey: ', event.ctrlKey);
        //  this.rr.current.innerText = `keyCode: ${event.keyCode} key:  ${event.key} ctrlKey: ${event.ctrlKey}`;
        event.preventDefault();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "hideKeyboard", function () {
      _this.inputRef.current.blur();
    });

    _defineProperty(_assertThisInitialized(_this), "handlePaste", function (event) {
      event.preventDefault();
      if (_this.props.disabled || _this.props.readOnly) return;
      var d = (event.clipboardData || window.clipboardData).getData('text').trim();

      _this.stringArrived(d);
    });

    _defineProperty(_assertThisInitialized(_this), "handleInput", function (event) {
      event.preventDefault();
      if (_this.props.disabled || _this.props.readOnly) return;
      if (_this.values.valueToShow === event.target.value) return;
      var d = event.target.value;

      _this.stringArrived(d);

      if (_this.inputRef.current.value !== _this.values.valueToShow) {
        _this.inputRef.current.value = _this.values.valueToShow;

        _this.inputRef.current.setSelectionRange(_this.values.selectionStart, _this.values.selectionEnd);
      }

      if ((0, _dateUtils.hasStringACharToGoToNext)(d)) {
        _this.jumpToNext();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "stringArrived", function (d) {
      d = (0, _dateUtils.mapToLatin)(d);
      var date = (0, _dateUtils.isValueValidDateTime)(d, _this.props.gregorian);

      if (!date) {
        date = new Date(d);

        if (date.toString() === 'Invalid Date') {
          date = false;
        }
      }

      if (!!date) {
        var value;

        if (_this.props.gregorian) {
          value = (0, _dateUtils.formatGregorian)(date);
        } else {
          var j = _jalaaliJs.default.toJalaali(date.getFullYear(), date.getMonth() + 1, date.getDate());

          value = (0, _dateUtils.formatJalaali)(j);
        }

        value = value + MIDDLE_SEPERATOR + (0, _dateUtils.formatTime)(date);
        var valueIsValid = true;
        var iso = date.toISOString();

        var valueToShow = _this.mapValue(value, _this.props.numberFormat);

        var newState = {
          value: value,
          valueToShow: valueToShow,
          valueIsValid: valueIsValid,
          iso: iso,
          date: date,
          selectionStart: undefined,
          selectionEnd: undefined
        };

        _this.updateState(newState);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "mapValue", function (value, numberFormat) {
      if (numberFormat === _dateUtils.NUMBER_FORMAT_FARSI) {
        var _mapped = (0, _dateUtils.mapToFarsi)(value);

        return _mapped;
      } else if (numberFormat === _dateUtils.NUMBER_FORMAT_LATIN) {
        var _mapped2 = (0, _dateUtils.mapToLatin)(value);

        return _mapped2;
      }

      var mapped = (0, _dateUtils.mapToFarsi)(value);
      return mapped;
    });

    _defineProperty(_assertThisInitialized(_this), "updateState", function (newState, noFireOnChange) {
      if (!newState) return;
      _this.values = newState;

      if (!_this.values.value) {
        _this.values.iso = '';
        _this.values.date = null;
        _this.values.valueIsValid = false;
      } else {
        if (newState.date) {
          _this.values.valueIsValid = true;
          _this.values.date = newState.date;
          _this.values.iso = newState.iso ? newState.iso : _this.values.date.toISOString();
        } else {
          var date = (0, _dateUtils.isValueValidDateTime)(_this.values.value, _this.props.gregorian);
          _this.values.valueIsValid = !!date;

          if (_this.values.valueIsValid) {
            _this.values.date = date;
            _this.values.iso = _this.values.date.toISOString();
          } else {
            _this.values.date = null;
            _this.values.iso = '';
          }
        }
      } // let fireOnChangeInTheEnd = false;
      // console.log('values on updateState', this.values)


      if (_this.inputRef.current.value !== _this.values.valueToShow) {
        // fireOnChangeInTheEnd = true;
        _this.inputRef.current.value = _this.values.valueToShow;
      }

      if (_this.inputRef.current === document.activeElement) {
        // console.log('has focus :D', this.values.selectionStart, this.values.selectionEnd);
        _this.inputRef.current.setSelectionRange(_this.values.selectionStart, _this.values.selectionEnd);
      } else {// console.log('has not focus :(');
      } // if(fireOnChangeInTheEnd){


      if (!noFireOnChange) {
        _this.fireOnChange();
      } // }

    });

    _defineProperty(_assertThisInitialized(_this), "updateValue", function (element, enteredValue, numberFormat) {
      var enteredValueMapped = _this.mapValue(enteredValue, numberFormat);

      var valueToShow = element.value;
      var selectionStart = element.selectionStart;
      var selectionEnd = element.selectionEnd;

      if (valueToShow === '') {
        valueToShow = EMPTY_VALUE;
        selectionStart = 10;
        selectionEnd = 10;
      }

      valueToShow = valueToShow.substring(0, selectionStart) + enteredValueMapped + valueToShow.substring(selectionEnd);
      selectionStart += enteredValueMapped.length;
      selectionEnd = selectionStart;
      var value = (0, _dateUtils.mapToLatin)(valueToShow);

      var values = _this.inspectValues({
        value: value,
        valueToShow: valueToShow,
        selectionStart: selectionStart,
        selectionEnd: selectionEnd
      });

      return values;
    });

    _defineProperty(_assertThisInitialized(_this), "isCaretAtDay", function (splittedValue, selectionStart) {
      return splittedValue && selectionStart <= splittedValue.seperator3 && selectionStart > splittedValue.seperator2;
    });

    _defineProperty(_assertThisInitialized(_this), "isCaretAtMonth", function (splittedValue, selectionStart) {
      return splittedValue && selectionStart <= splittedValue.seperator2 && selectionStart > splittedValue.seperator1;
    });

    _defineProperty(_assertThisInitialized(_this), "isCaretAtYear", function (splittedValue, selectionStart) {
      return splittedValue && selectionStart <= splittedValue.seperator1;
    });

    _defineProperty(_assertThisInitialized(_this), "isCaretAtHour", function (splittedValue, selectionStart) {
      return splittedValue && selectionStart <= splittedValue.seperator4 && selectionStart > splittedValue.seperator3;
    });

    _defineProperty(_assertThisInitialized(_this), "isCaretAtMinute", function (splittedValue, selectionStart) {
      return splittedValue && selectionStart > splittedValue.seperator4;
    });

    _defineProperty(_assertThisInitialized(_this), "sanitizeValues", function (splittedValue, values, sanitizeDay, sanitizeMonth, sanitizeYear, sanitizeHour, sanitizeMinute) {
      var value = values.value;

      if (splittedValue === '') {
        return null;
      }

      if (!splittedValue) {
        return _this.resetValues();
      }

      var year = splittedValue.year,
          month = splittedValue.month,
          day = splittedValue.day,
          hour = splittedValue.hour,
          minute = splittedValue.minute;

      if (sanitizeDay) {
        if (day.length === 0) {
          day = '  ';
        } else if (day.length === 1) {
          if (day === '0' || day === ' ') {
            day = '  ';
          } else {
            day = '0' + day;
          }
        }
      }

      if (sanitizeMonth) {
        if (month.length === 0) {
          month = '  ';
        } else if (month.length === 1) {
          if (month === '0' || month === ' ') {
            month = '  ';
          } else {
            month = '0' + month;
          }
        }
      }

      if (sanitizeYear) {
        year = year.trim();
        year = (0, _dateUtils.baseYear)(_this.props.gregorian).substring(0, 4 - year.length) + year;
      }

      if (sanitizeHour) {
        if (hour.length === 0) {
          hour = '00';
        } else if (hour.length === 1) {
          if (hour === '0' || hour === ' ') {
            hour = '00';
          } else {
            hour = '0' + hour;
          }
        }
      }

      if (sanitizeMinute) {
        if (minute.length === 0) {
          minute = '00';
        } else if (minute.length === 1) {
          if (minute === '0' || minute === ' ') {
            minute = '00';
          } else {
            minute = '0' + minute;
          }
        }
      }

      var newValue = "".concat(year).concat(DATE_SEPERATOR).concat(month).concat(DATE_SEPERATOR).concat(day).concat(MIDDLE_SEPERATOR).concat(hour).concat(TIME_SEPERATOR).concat(minute);

      if (value !== newValue) {
        return _objectSpread({}, values, {
          value: newValue,
          valueToShow: _this.mapValue(newValue, _this.props.numberFormat)
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "inspectValues", function (values) {
      var value = values.value;
      var splittedValue = (0, _dateUtils.splitDateTimeValue)(value);

      if (!splittedValue) {
        return _this.resetValues();
      }

      var year = splittedValue.year,
          month = splittedValue.month,
          day = splittedValue.day,
          hour = splittedValue.hour,
          minute = splittedValue.minute;
      var newStartPosition = values.selectionStart;

      if (_this.isCaretAtDay(splittedValue, values.selectionStart)) {
        var inspected = (0, _dateUtils.inspectDay)(day, values.selectionStart, splittedValue.seperator2, (0, _dateUtils.maxDayFor)(year, month, _this.props.gregorian));
        newStartPosition = inspected.newStartPosition;
        day = inspected.newDay;
      } else if (_this.isCaretAtMonth(splittedValue, values.selectionStart)) {
        var _inspected = (0, _dateUtils.inspectMonth)(month, values.selectionStart, splittedValue.seperator1);

        newStartPosition = _inspected.newStartPosition;
        month = _inspected.newMonth;
      } else if (_this.isCaretAtYear(splittedValue, values.selectionStart)) {
        var _inspected2 = (0, _dateUtils.inspectYear)(year, values.selectionStart);

        newStartPosition = _inspected2.newStartPosition;
        year = _inspected2.newYear;
      } else if (_this.isCaretAtHour(splittedValue, values.selectionStart)) {
        var _inspected3 = (0, _dateUtils.inspectHour)(hour, values.selectionStart, splittedValue.seperator3);

        newStartPosition = _inspected3.newStartPosition;
        hour = _inspected3.newHour;
      } else if (_this.isCaretAtMinute(splittedValue, values.selectionStart)) {
        var _inspected4 = (0, _dateUtils.inspectMinute)(minute, values.selectionStart, splittedValue.seperator4);

        newStartPosition = _inspected4.newStartPosition;
        minute = _inspected4.newMinute;
      }

      var newValue = "".concat(year).concat(DATE_SEPERATOR).concat(month).concat(DATE_SEPERATOR).concat(day).concat(MIDDLE_SEPERATOR).concat(hour).concat(TIME_SEPERATOR).concat(minute);
      return {
        value: newValue,
        valueToShow: _this.mapValue(newValue, _this.props.numberFormat),
        selectionStart: newStartPosition,
        selectionEnd: newStartPosition
      };
    });

    _defineProperty(_assertThisInitialized(_this), "resetValues", function () {
      var value = '';
      return {
        value: value,
        valueToShow: _this.mapValue(value, _this.props.numberFormat),
        selectionStart: 10,
        selectionEnd: 10
      };
    });

    _defineProperty(_assertThisInitialized(_this), "deleteValue", function (element, qty) {
      var valueToShow = element.value;
      var selectionStart = element.selectionStart;
      var selectionEnd = element.selectionEnd;

      if (selectionStart === selectionEnd) {
        if (qty < 0) {
          if (selectionStart === 0) return;
          var toBeDeleted = valueToShow.substring(selectionStart + qty, selectionStart);
          if (toBeDeleted === DATE_SEPERATOR || toBeDeleted === MIDDLE_SEPERATOR || toBeDeleted === TIME_SEPERATOR) return;
          valueToShow = valueToShow.substring(0, selectionStart + qty) + valueToShow.substring(selectionEnd);
          selectionStart += qty;
        } else {
          if (selectionEnd === valueToShow.length) return;

          var _toBeDeleted = valueToShow.substring(selectionStart, selectionStart + qty);

          if (_toBeDeleted === DATE_SEPERATOR || _toBeDeleted === MIDDLE_SEPERATOR || _toBeDeleted === TIME_SEPERATOR) return;
          valueToShow = valueToShow.substring(0, selectionStart) + valueToShow.substring(selectionEnd + qty);
        }
      } else {
        valueToShow = valueToShow.substring(0, selectionStart) + valueToShow.substring(selectionEnd);
      }

      selectionEnd = selectionStart;
      var value = (0, _dateUtils.mapToLatin)(valueToShow);

      var values = _this.inspectValues({
        value: value,
        valueToShow: valueToShow,
        selectionStart: selectionStart,
        selectionEnd: selectionEnd
      });

      return values;
    });

    _defineProperty(_assertThisInitialized(_this), "fireOnChange", function () {
      if (_this.props.onChange) {
        var value = _this.values.valueIsValid ? _this.values.value : '';

        if (_this.previousValue !== value) {
          _this.previousValue = value;
          var target = !_this.values.valueIsValid ? {
            name: _this.props.name,
            formatted: '',
            value: '',
            date: null
          } : {
            name: _this.props.name,
            value: _this.values.iso,
            formatted: _this.values.value,
            date: _this.values.date
          };

          _this.props.onChange({
            target: target
          });
        }
      }
    });

    _this.emptyValue = _this.emptyValue.bind(_assertThisInitialized(_this));
    var ref;

    if (_props.inputRef && typeof _props.inputRef === 'function') {
      ref = _props.inputRef();
    } else if (_props.inputRef && _typeof(_props.inputRef) === 'object') {
      ref = _props.inputRef;
    }

    _this.inputRef = ref ? ref : /*#__PURE__*/_react.default.createRef(); // this.rr = React.createRef();

    _this.values = _this.readValuesFromProps(_props);
    _this.previousValue = _this.values.value;
    return _this;
  }

  _createClass(DateInput, [{
    key: "emptyValue",
    value: function emptyValue() {
      this.updateState(this.resetValues());
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextProps.value !== this.props.value && nextProps.value !== this.values.iso || nextProps.gregorian !== this.props.gregorian || nextProps.numberFormat !== this.props.numberFormat) {
        this.updateState(this.readValuesFromProps(nextProps), true);
      }

      if (!(0, _objects.default)(nextProps.style, this.props.style)) {
        return true;
      }

      if (nextProps.className !== this.props.className) {
        this.inputRef.current.className = nextProps.className;
      }

      if (nextProps.disabled !== this.props.disabled) {
        this.inputRef.current.disabled = nextProps.disabled;
      }

      if (nextProps.readOnly !== this.props.readOnly) {
        this.inputRef.current.readOnly = nextProps.readOnly;
      }

      if (nextProps.placeholder !== this.props.placeholder) {
        this.inputRef.current.placeholder = nextProps.placeholder;
      }

      return false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          gregorian = _this$props.gregorian,
          value = _this$props.value,
          onChange = _this$props.onChange,
          onFocus = _this$props.onFocus,
          onBlur = _this$props.onBlur,
          onInput = _this$props.onInput,
          onPaste = _this$props.onPaste,
          onKeyDown = _this$props.onKeyDown,
          onShowDialog = _this$props.onShowDialog,
          pattern = _this$props.pattern,
          inputMode = _this$props.inputMode,
          defaultValue = _this$props.defaultValue,
          type = _this$props.type,
          inputRef = _this$props.inputRef,
          numberFormat = _this$props.numberFormat,
          rest = _objectWithoutProperties(_this$props, ["gregorian", "value", "onChange", "onFocus", "onBlur", "onInput", "onPaste", "onKeyDown", "onShowDialog", "pattern", "inputMode", "defaultValue", "type", "inputRef", "numberFormat"]);

      var valueToShow = this.values.valueToShow; // const localInputMode = this.props.type === 'tel' ? 'tel' : 'numeric'; // as we use type=tel, then we do not need it any more
      // const localPattern = '[0-9]*'; // it has problem with the form checking, as we insert persian digit, it is not acceptable for the browser

      return /*#__PURE__*/_react.default.createElement("input", _extends({
        ref: this.inputRef,
        type: "tel" // I tried to use text and using inputMode, but it does not work on Safari
        // inputMode={localInputMode}
        // xInputMode={localnputMode} // in firefox OS it is x-inputmode, I do not know how to handle it
        ,
        dir: "ltr" // pattern={localPattern}
        ,
        defaultValue: valueToShow,
        onKeyDown: this.handleKeyDown,
        onPaste: this.handlePaste,
        onInput: this.handleInput,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur
      }, rest)); //<p ref={this.rr} type={"text"}>empty</p></div>
    }
  }]);

  return DateInput;
}(_react.Component);

_defineProperty(DateInput, "propTypes", {
  /**
   * The ref to pass on the input, if empty it will be created internally
   */
  inputRef: _propTypes.default.any,

  /**
   * The name that will be set while firing the onChange event in the target object
   */
  name: _propTypes.default.string,

  /**
   * The number format to show 'FARSI' / 'LATIN'
   */
  numberFormat: _propTypes.default.string,

  /**
   * Callback function that is fired when the date value changes.
   * @param {string} date and time, The new date and time in iso 8601 format like 2018-08-23T21:06:50Z
   * it is always UTC
   */
  onChange: _propTypes.default.func,

  /**
   * Override the inline-styles of the root element.
   */
  style: _propTypes.default.object,

  /**
   * The css class name of the root element.
   */
  className: _propTypes.default.string,

  /**
   * Disables the DateTimeInput.
   */
  disabled: _propTypes.default.bool,

  /**
   * makes the DateTimeInput readonly.
   */
  readOnly: _propTypes.default.bool,

  /**
   * Callback function that is fired when a click event occurs on the Date Picker's `TextField`.
   * @param {object} event Click event targeting the `main div element`.
   */
  onClick: _propTypes.default.func,

  /**
   * Callback function that is fired when the Date-Time input's `main div` gains focus.
   */
  onFocus: _propTypes.default.func,

  /**
   * Callback function that is fired when the user press F4 to open the dialog.
   */
  onShowDialog: _propTypes.default.func,

  /**
   * makes the DateTimeInput gregorian.
   */
  gregorian: _propTypes.default.bool,

  /**
   * Sets the value for the Date-Time input.
   */
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.instanceOf(Date)])
});

_defineProperty(DateInput, "defaultProps", {
  style: {}
});

var _default = DateInput;
exports.default = _default;